"use strict";

var _interopRequireWildcard = require("@babel/runtime/helpers/interopRequireWildcard");

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = exports.Consumer = exports.Provider = void 0;

var _extends2 = _interopRequireDefault(require("@babel/runtime/helpers/extends"));

var _objectWithoutPropertiesLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/objectWithoutPropertiesLoose"));

var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));

var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));

var _createClass2 = _interopRequireDefault(require("@babel/runtime/helpers/createClass"));

var _assertThisInitialized2 = _interopRequireDefault(require("@babel/runtime/helpers/assertThisInitialized"));

var _inheritsLoose2 = _interopRequireDefault(require("@babel/runtime/helpers/inheritsLoose"));

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

var React = _interopRequireWildcard(require("react"));

var _setStatic = _interopRequireDefault(require("recompose/setStatic"));

var _classnames = _interopRequireDefault(require("classnames"));

var _recompose = require("recompose");

var _domLib = require("dom-lib");

var _utils = require("./utils");

var _utils2 = require("../utils");

var _ListItem = _interopRequireDefault(require("./ListItem"));

var _Manager = _interopRequireDefault(require("./Manager"));

var _AutoScroller = _interopRequireDefault(require("./AutoScroller"));

var NodeType = {
  Anchor: 'A',
  Button: 'BUTTON',
  Canvas: 'CANVAS',
  Input: 'INPUT',
  Option: 'OPTION',
  Textarea: 'TEXTAREA',
  Select: 'SELECT'
};
var interactiveElements = [NodeType.Input, NodeType.Textarea, NodeType.Select, NodeType.Option, NodeType.Button];
var EVENTS = {
  end: ['touchend', 'touchcancel', 'mouseup'],
  move: ['touchmove', 'mousemove'],
  start: ['touchstart', 'mousedown']
};
var defaultContext = {
  bordered: false,
  size: 'md',
  manager: null
};

var _React$createContext = React.createContext(defaultContext),
    Provider = _React$createContext.Provider,
    Consumer = _React$createContext.Consumer;
/*
* Main Class
* */


exports.Consumer = Consumer;
exports.Provider = Provider;

var List =
/*#__PURE__*/
function (_React$Component) {
  (0, _inheritsLoose2.default)(List, _React$Component);

  function List() {
    var _this;

    for (var _len = arguments.length, args = new Array(_len), _key = 0; _key < _len; _key++) {
      args[_key] = arguments[_key];
    }

    _this = _React$Component.call.apply(_React$Component, [this].concat(args)) || this;
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "node", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "sortableGhost", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "helper", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "container", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "scrollContainer", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "listenerNode", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "autoScroller", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "manager", new _Manager.default());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "touched", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "sorting", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "position", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "height", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "width", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "margin", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "marginOffset", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "index", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "newIndex", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "pressTimer", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "cancelTimer", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "translate", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "minTranslate", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "maxTranslate", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "initialOffset", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "offsetEdge", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "initialScroll", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "initialWindowScroll", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "boundingClientRect", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "containerBoundingRect", void 0);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "animatedNodeOffset", []);
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "dealListener", function (action) {
      var eventFunctions = {
        end: _this.handleEnd,
        move: _this.handleMove,
        start: _this.handleStart
      };

      switch (action) {
        case 'add':
          return Object.keys(eventFunctions).forEach(function (key) {
            return EVENTS[key].forEach(function (eventName) {
              return _this.container && (0, _domLib.on)(_this.container, eventName, eventFunctions[key], {
                passive: false
              });
            });
          });

        case 'remove':
          return Object.keys(eventFunctions).forEach(function (key) {
            return EVENTS[key].forEach(function (eventName) {
              return _this.container && (0, _domLib.off)(_this.container, eventName, eventFunctions[key]);
            });
          });
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleStart", function (event) {
      var _this$props = _this.props,
          sortable = _this$props.sortable,
          pressDelay = _this$props.pressDelay;
      var targetNode = event.target instanceof Element && event.target;
      var node = (0, _utils.closest)(event.target, function (el) {
        return !!el.sortableInfo;
      });

      if (targetNode && //is sortable
      sortable && //is list item
      node && node.sortableInfo && !node.sortableInfo.disabled && //is not secondary button pressed
      event.button !== 2 && //is this list
      node.sortableInfo.manager === _this.manager && //excludes interactive elements
      node instanceof Element && !node.contains((0, _utils.closest)(targetNode, function (el) {
        return interactiveElements.includes(el.tagName) || el.contentEditable === 'true';
      })) && //is not sorting
      !_this.sorting) {
        var _node$sortableInfo = node.sortableInfo,
            index = _node$sortableInfo.index,
            collection = _node$sortableInfo.collection;
        _this.touched = true;
        _this.position = (0, _utils.getPosition)(event);
        _this.manager.active = {
          collection: collection,
          index: index
        };
        /*
         * Fixes a bug in Firefox where the :active state of anchor tags
         * prevent subsequent 'mousemove' events from being fired
         */

        if (!(0, _get2.default)(event, ['touches', 'length']) && !(0, _get2.default)(event, ['changedTouches', 'length']) && event.target instanceof Element && event.target.tagName === NodeType.Anchor) {
          event.preventDefault();
        }

        if (pressDelay === 0) {
          _this.handlePress(event);
        } else {
          _this.pressTimer = setTimeout(function () {
            return _this.handlePress(event);
          }, pressDelay);
        }
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleMove", function (event) {
      var pressThreshold = _this.props.pressThreshold;

      if (!_this.sorting && _this.touched) {
        var position = (0, _utils.getPosition)(event);
        var delta = {
          x: _this.position.x - (0, _get2.default)(position, 'x', 0),
          y: _this.position.y - (0, _get2.default)(position, 'y', 0)
        };
        var combinedDelta = Math.abs(+delta.x) + Math.abs(+delta.y);

        if (!pressThreshold || combinedDelta >= pressThreshold) {
          clearTimeout(_this.cancelTimer);
          _this.cancelTimer = setTimeout(_this.cancel, 0);
        }
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleEnd", function () {
      _this.touched = false;

      _this.cancel();
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "cancel", function () {
      if (!_this.sorting) {
        clearTimeout(_this.pressTimer);
        _this.manager.active = null;
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handlePress",
    /*#__PURE__*/
    function () {
      var _ref = (0, _asyncToGenerator2.default)(
      /*#__PURE__*/
      _regenerator.default.mark(function _callee(event) {
        var active, _this$props2, classPrefix, onSortStart, node, collection, index, addItemPrefix, style, margin, dimensions;

        return _regenerator.default.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                active = _this.manager.getActive();

                if (active) {
                  _context.next = 3;
                  break;
                }

                return _context.abrupt("return");

              case 3:
                _this$props2 = _this.props, classPrefix = _this$props2.classPrefix, onSortStart = _this$props2.onSortStart;
                node = active.node, collection = active.collection;
                index = node.sortableInfo.index;
                addItemPrefix = (0, _utils2.prefix)(classPrefix + '-item');
                style = window.getComputedStyle(node);
                margin = {
                  bottom: parseFloat(style.marginBottom),
                  left: parseFloat(style.marginLeft),
                  right: parseFloat(style.marginRight),
                  top: parseFloat(style.marginTop)
                };
                dimensions = {
                  height: node.offsetHeight,
                  width: node.offsetWidth
                };
                _this.node = node;
                _this.margin = margin;
                _this.width = dimensions.width;
                _this.height = dimensions.height;
                _this.marginOffset = {
                  x: _this.margin.left + _this.margin.right,
                  y: Math.max(_this.margin.top, _this.margin.bottom)
                };
                _this.boundingClientRect = node.getBoundingClientRect();
                _this.containerBoundingRect = _this.scrollContainer.getBoundingClientRect();
                _this.index = index;
                _this.newIndex = index;
                _this.offsetEdge = (0, _utils.getEdgeOffset)(node, _this.container);
                _this.initialOffset = (0, _utils.getPosition)(event);
                _this.initialScroll = {
                  left: _this.scrollContainer.scrollLeft,
                  top: _this.scrollContainer.scrollTop
                };
                _this.initialWindowScroll = {
                  left: window.pageXOffset,
                  top: window.pageYOffset
                };
                _this.helper = document.body && document.body.appendChild(node.cloneNode(true));
                _this.helper && _this.helper.classList.add(addItemPrefix('helper'));
                (0, _utils.setInlineStyles)(_this.helper, {
                  width: _this.width + "px",
                  height: _this.height + "px",
                  position: 'fixed',
                  left: _this.boundingClientRect.left - margin.left + "px",
                  top: _this.boundingClientRect.top - margin.top + "px"
                });
                _this.sortableGhost = node;
                node.classList.add(addItemPrefix('holder'));
                _this.minTranslate = {};
                _this.maxTranslate = {};
                _this.minTranslate.y = _this.containerBoundingRect.top - _this.boundingClientRect.top - _this.height / 2;
                _this.maxTranslate.y = _this.containerBoundingRect.top + _this.containerBoundingRect.height - _this.boundingClientRect.top - _this.height / 2;
                _this.listenerNode = event.touches ? node : window;
                EVENTS.move.forEach(function (eventName) {
                  return (0, _domLib.on)(_this.listenerNode, eventName, _this.handleSortMove, {
                    passive: false
                  });
                });
                EVENTS.end.forEach(function (eventName) {
                  return (0, _domLib.on)(_this.listenerNode, eventName, _this.handleSortEnd, {
                    passive: false
                  });
                });
                _this.sorting = true;

                if (onSortStart) {
                  onSortStart({
                    collection: collection,
                    index: index,
                    node: node
                  }, event);
                }

              case 37:
              case "end":
                return _context.stop();
            }
          }
        }, _callee);
      }));

      return function (_x) {
        return _ref.apply(this, arguments);
      };
    }());
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleSortMove", function (event) {
      var onSortMove = _this.props.onSortMove; // Prevent scrolling on mobile

      event.preventDefault();

      _this.updateHelperPosition(event);

      _this.animateNodes();

      _this.autoScroll();

      if (onSortMove) {
        onSortMove(event);
      }
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "handleSortEnd", function (event) {
      var _this$props3 = _this.props,
          onSortEnd = _this$props3.onSortEnd,
          onSort = _this$props3.onSort,
          classPrefix = _this$props3.classPrefix,
          transitionDuration = _this$props3.transitionDuration;
      var ActiveCollection = (0, _get2.default)(_this.manager, ['active', 'collection'], null);
      var nodes = _this.manager.refs[ActiveCollection];
      var addItemPrefix = (0, _utils2.prefix)(classPrefix + '-item'); // Remove the event listeners if the node is still in the DOM

      if (_this.listenerNode) {
        EVENTS.move.forEach(function (eventName) {
          return (0, _domLib.off)(_this.listenerNode, eventName, _this.handleSortMove);
        });
        EVENTS.end.forEach(function (eventName) {
          return (0, _domLib.off)(_this.listenerNode, eventName, _this.handleSortEnd);
        });
      }

      (0, _utils.setTranslate3d)(_this.helper, _this.holderTranslate);
      (0, _utils.setTransitionDuration)(_this.helper, transitionDuration); // wait for animation

      setTimeout(function () {
        // Remove the helper from the DOM
        if (_this.helper) {
          _this.helper.parentNode && _this.helper.parentNode.removeChild(_this.helper);
          _this.helper = null;
        }

        if (_this.sortableGhost) {
          _this.sortableGhost.classList.remove(addItemPrefix('holder'));

          (0, _utils.setTranslate3d)(_this.sortableGhost, null);
          _this.animatedNodeOffset = [];
        }

        for (var i = 0, len = nodes.length; i < len; i++) {
          var node = nodes[i];
          var el = node.node; // Clear the cached offsetTop / offsetLeft value

          node.edgeOffset = null; // Remove the transforms / transitions

          (0, _utils.setTranslate3d)(el, null);
          (0, _utils.setTransitionDuration)(el, null);
        } // Stop autoScroll


        _this.autoScroller.clear(); // Update manager state


        _this.manager.active = null;
        _this.sorting = false;

        if (typeof onSortEnd === 'function') {
          onSortEnd({
            collection: ActiveCollection,
            newIndex: _this.newIndex,
            oldIndex: _this.index
          }, event);
        }

        if (typeof onSort === 'function') {
          onSort({
            collection: ActiveCollection,
            newIndex: _this.newIndex,
            oldIndex: _this.index
          }, event);
        }

        _this.touched = false;
      }, transitionDuration);
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "autoScroll", function () {
      var autoScroll = _this.props.autoScroll;

      if (!autoScroll) {
        return;
      }

      _this.autoScroller.update({
        height: _this.height,
        maxTranslate: _this.maxTranslate,
        minTranslate: _this.minTranslate,
        translate: _this.translate,
        width: _this.width
      });
    });
    (0, _defineProperty2.default)((0, _assertThisInitialized2.default)(_this), "onAutoScroll", function (offset) {
      _this.translate.x += offset.left;
      _this.translate.y += offset.top;

      _this.animateNodes();
    });
    return _this;
  }

  var _proto = List.prototype;

  _proto.componentDidMount = function componentDidMount() {
    if (this.container instanceof Element) {
      this.scrollContainer = (0, _utils.getScrollingParent)(this.container) || this.container;
      this.autoScroller = new _AutoScroller.default(this.scrollContainer, this.onAutoScroll);
      this.dealListener('add');
    }
  };

  _proto.componentWillUnmount = function componentWillUnmount() {
    this.dealListener('remove');
  };

  _proto.updateHelperPosition = function updateHelperPosition(event) {
    var offset = (0, _utils.getPosition)(event);
    var translate = {
      x: (0, _get2.default)(offset, 'x', 0) - this.initialOffset.x,
      y: (0, _get2.default)(offset, 'y', 0) - this.initialOffset.y
    }; // Adjust for window scroll

    translate.y -= window.pageYOffset - (this.initialWindowScroll.top || 0);
    translate.x -= window.pageXOffset - (this.initialWindowScroll.left || 0);
    this.translate = translate;
    (0, _utils.setTranslate3d)(this.helper, translate);
  };

  _proto.animateNodes = function animateNodes() {
    var _this$props4 = this.props,
        transitionDuration = _this$props4.transitionDuration,
        onSortOver = _this$props4.onSortOver;
    var containerScrollDelta = this.containerScrollDelta,
        windowScrollDelta = this.windowScrollDelta;
    var nodes = this.manager.getOrderedRefs();
    var sortingOffset = {
      left: this.offsetEdge.left + this.translate.x + containerScrollDelta.left,
      top: this.offsetEdge.top + this.translate.y + containerScrollDelta.top
    };
    var prevIndex = this.newIndex;
    this.newIndex = -1;

    for (var i = 0, len = nodes.length; i < len; i++) {
      var node = nodes[i].node;
      var index = node.sortableInfo.index;
      var width = node.offsetWidth;
      var height = node.offsetHeight;
      var offset = {
        height: this.height > height ? height / 2 : this.height / 2,
        width: this.width > width ? width / 2 : this.width / 2
      };
      var translate = {
        x: 0,
        y: 0
      };
      var edgeOffset = nodes[i].edgeOffset; // If we haven't cached the node's offsetTop / offsetLeft value

      if (!edgeOffset) {
        edgeOffset = (0, _utils.getEdgeOffset)(node, this.container);
        nodes[i].edgeOffset = edgeOffset;
      } // Get a reference to the next and previous node


      var nextNode = i < nodes.length - 1 && nodes[i + 1]; // Also cache the next node's edge offset if needed.
      // We need this for calculating the animation in a grid setup

      if (nextNode && !nextNode.edgeOffset) {
        nextNode.edgeOffset = (0, _utils.getEdgeOffset)(nextNode.node, this.container);
      } // If the node is the one we're currently animating, skip it


      if (index === this.index) {
        continue;
      }

      (0, _utils.setTransitionDuration)(node, transitionDuration);
      var offsetY = this.height + this.marginOffset.y;
      var distanceTop = sortingOffset.top + windowScrollDelta.top;

      if (index > this.index && distanceTop + offset.height >= edgeOffset.top) {
        translate.y = -offsetY;
        this.newIndex = index;
      } else if (index < this.index && distanceTop <= edgeOffset.top + offset.height) {
        translate.y = offsetY;

        if (this.newIndex === -1) {
          this.newIndex = index;
        }
      }

      (0, _utils.setTranslate3d)(node, translate); // translate holder

      this.animatedNodeOffset[index] = translate;
      (0, _utils.setTranslate3d)(this.sortableGhost, this.holderTranslate);
    }

    if (this.newIndex === -1) {
      this.newIndex = this.index;
    }

    if (onSortOver && this.newIndex !== prevIndex) {
      onSortOver({
        collection: (0, _get2.default)(this.manager, ['active', 'collection']),
        index: this.index,
        newIndex: this.newIndex,
        oldIndex: prevIndex
      });
    }
  };

  _proto.render = function render() {
    var _classNames,
        _this2 = this;

    var _this$props5 = this.props,
        className = _this$props5.className,
        classPrefix = _this$props5.classPrefix,
        bordered = _this$props5.bordered,
        hover = _this$props5.hover,
        size = _this$props5.size,
        sortable = _this$props5.sortable,
        children = _this$props5.children,
        rest = (0, _objectWithoutPropertiesLoose2.default)(_this$props5, ["className", "classPrefix", "bordered", "hover", "size", "sortable", "children"]);
    var addPrefix = (0, _utils2.prefix)(classPrefix);
    var unhandled = (0, _utils2.getUnhandledProps)(List, rest);
    var classes = (0, _classnames.default)(classPrefix, className, (_classNames = {}, _classNames[addPrefix('bordered')] = bordered, _classNames[addPrefix('sortable')] = sortable, _classNames[addPrefix('sorting')] = this.sorting, _classNames[addPrefix('hover')] = hover, _classNames));
    var contextValue = {
      bordered: bordered,
      size: size,
      manager: this.manager
    };
    return React.createElement(Provider, {
      value: contextValue
    }, React.createElement("div", (0, _extends2.default)({
      ref: function ref(_ref2) {
        return _this2.container = _ref2;
      },
      className: classes
    }, unhandled), children));
  };

  (0, _createClass2.default)(List, [{
    key: "containerScrollDelta",
    get: function get() {
      return {
        left: this.scrollContainer.scrollLeft - (this.initialScroll.left || 0),
        top: this.scrollContainer.scrollTop - (this.initialScroll.top || 0)
      };
    }
  }, {
    key: "windowScrollDelta",
    get: function get() {
      return {
        left: window.pageXOffset - (this.initialWindowScroll.left || 0),
        top: window.pageYOffset - (this.initialWindowScroll.top || 0)
      };
    }
  }, {
    key: "holderTranslate",
    get: function get() {
      var _this3 = this;

      var translateX = 0;
      var translateY = 0;
      this.animatedNodeOffset.forEach(function (_ref3, index) {
        var x = _ref3.x,
            y = _ref3.y;

        var nodeItems = _this3.manager.getOrderedRefs();

        var nodeItem = nodeItems.find(function (nodeInfo) {
          return (0, _get2.default)(nodeInfo, ['node', 'sortableInfo', 'index']) === index;
        });
        var node = (0, _get2.default)(nodeItem, 'node');

        if (!nodeItem || !node) {
          return;
        }

        var style = window.getComputedStyle(node);
        var margin = {
          bottom: parseFloat(style.marginBottom),
          left: parseFloat(style.marginLeft),
          right: parseFloat(style.marginRight),
          top: parseFloat(style.marginTop)
        };
        var marginOffset = {
          x: margin.left + margin.right,
          y: Math.max(margin.top, margin.bottom)
        };

        if (!nodeItem.edgeOffset) {
          nodeItem.edgeOffset = (0, _utils.getEdgeOffset)(node, _this3.container);
        }

        var offsetX = node.offsetWidth + marginOffset.x;
        var offsetY = node.offsetHeight + marginOffset.y;

        if (x) {
          translateX += +x / Math.abs(+x) * offsetX;
        }

        if (y) {
          translateY += +y / Math.abs(+y) * offsetY;
        }
      });
      return {
        x: (this.initialScroll.left || 0) - this.scrollContainer.scrollLeft - translateX,
        y: (this.initialScroll.top || 0) - this.scrollContainer.scrollTop - translateY
      };
    }
  }]);
  return List;
}(React.Component);

(0, _defineProperty2.default)(List, "defaultProps", {
  size: 'md',
  autoScroll: true,
  pressDelay: 0,
  pressThreshold: 5,
  transitionDuration: 300
});
(0, _defineProperty2.default)(List, "handledProps", ["autoScroll", "bordered", "children", "className", "classPrefix", "hover", "onSort", "onSortEnd", "onSortMove", "onSortOver", "onSortStart", "pressDelay", "pressThreshold", "size", "sortable", "transitionDuration"]);
var EnhancedList = (0, _utils2.defaultProps)({
  classPrefix: 'list'
})(List);
(0, _setStatic.default)('Item', _ListItem.default)(EnhancedList);
var Component = (0, _recompose.setDisplayName)('List')(EnhancedList);
var _default = Component;
exports.default = _default;