"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");

exports.__esModule = true;
exports.default = void 0;

var _defineProperty2 = _interopRequireDefault(require("@babel/runtime/helpers/defineProperty"));

var _get2 = _interopRequireDefault(require("lodash/get"));

/*
* Move manager
* */
var Manager =
/*#__PURE__*/
function () {
  function Manager() {
    var _this = this;

    (0, _defineProperty2.default)(this, "refs", {});
    (0, _defineProperty2.default)(this, "active", void 0);
    (0, _defineProperty2.default)(this, "getActive", function () {
      var ActiveIndex = (0, _get2.default)(_this.active, 'index', null);
      var ActiveCollection = (0, _get2.default)(_this.active, 'collection', null);
      return ActiveIndex !== null && ActiveCollection !== null && _this.refs[ActiveCollection].find(function (_ref) {
        var node = _ref.node;
        return node.sortableInfo.index === ActiveIndex;
      });
    });
    (0, _defineProperty2.default)(this, "getIndex", function (collection, ref) {
      return _this.refs[collection].indexOf(ref);
    });
  }

  var _proto = Manager.prototype;

  _proto.add = function add(collection, ref) {
    if (!this.refs[collection]) {
      this.refs[collection] = [];
    }

    this.refs[collection].push(ref);
  };

  _proto.remove = function remove(collection, ref) {
    var index = this.getIndex(collection, ref);

    if (index !== -1) {
      if (Array.isArray(this.refs[collection])) {
        this.refs[collection].splice(index, 1);
      }
    }
  };

  _proto.getOrderedRefs = function getOrderedRefs(collection) {
    if (this.active !== null) {
      if (collection === undefined) {
        collection = this.active.collection;
      }

      return this.refs[collection].sort(function (nodeInfo1, nodeInfo2) {
        return nodeInfo1.node.sortableInfo.index - nodeInfo2.node.sortableInfo.index;
      });
    }

    return [];
  };

  return Manager;
}();

var _default = Manager;
exports.default = _default;